{===========================================================================}
{ Wiggly Worm '94 Special Edition         (C)Copyright J.P.Boggis 1994-2001 }
{===========================================================================}
{ Miscellaneous functions unit.                                             }
{---------------------------------------------------------------------------}
{ This program is free software; you can redistribute it and/or modify it   }
{ under the terms of the GNU General Public License as published by the     }
{ Free Software Foundation; either version 2 of the License, or (at your    }
{ option) any later version.                                                }
{                                                                           }
{ This program is distributed in the hope that it will be useful, but       }
{ WITHOUT ANY WARRANTY; without even the implied warranty of                }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         }
{ General Public License for more details.                                  }
{                                                                           }
{ You should have received a copy of the GNU General Public License along   }
{ with this program; if not, write to the Free Software Foundation, Inc.,   }
{ 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   }
{---------------------------------------------------------------------------}
{ Started by J.P.Boggis (AKA JC Digita) on 07/10/1993.                      }
{                                                                           }
{    Release 2.0  -  24/01/1994                                             }
{    Release 2.1  -  20/02/1994                                             }
{    Release 2.2  -  22/02/1994                                             }
{    Release 2.3  -  23/02/1994                                             }
{    Release 2.4  -  05/04/1994                                             }
{    Release 2.5  -  27/12/2000  -  Special Edition                         }
{===========================================================================}
{ email@jcdigita.com                                       www.jcdigita.com }
{===========================================================================}


{$S-}


unit wormunit;

interface

uses crt,dos,graph,wormhelp,keybiz,mouse;

const interrupts=true;

      verdate='27/12/2000';
      ver='2.5';

      {***  Player types (PTYPE)  ***}
      notplaying=0;
      human     =1;
      computer  =2;

      {***  Worm screen value types  ***}
      scrworm=1;
      scredge=2;
      scrwall=3;
      scricon=4;

      {***  Sound priorities  ***}
      sp_fire   =1;
      sp_icon   =2;
      sp_numb   =3;
      sp_notdead=4;
      sp_dead   =5;
      sp_nolives=6;
      sp_stun   =7;

      {***  Icon contol constants  ***}
      maximumicons=10;
      maxicons:word=5;

      icononscreen:byte =15;
      iconoffscreen:byte=10;

      levelendpoints:word=1000;

      keybuffersize=16;  {Size of key press buffer for each player}

      {***  Other constants  ***}
      computerlaser:boolean=true;
      fastcomputers:boolean=true;
      humanlaser:boolean=true;
      computerability:byte=10;  {***  Extremely good  ***}
      laserkills:boolean=true;
      iconprobability:byte=5;
      playerspeed:byte=6;
      playerlives:byte=4;
      wormmethod:byte=5;

      qpos:byte=1;         {***  Current position in sound queue  ***}
      qlen:byte=0;         {***   Current length of sound queue   ***}
      turntable:array[1..4,1..2] of byte=((4,2),(1,3),(2,4),(3,1));

      {***  Computer icon/number collection priorities  ***}
      iconpriority:array[1..24] of byte=(125,5,115,120,165,175,10,155,100,110,135,170,20,25,30,
                                         35,40,45,50,140,185,160,105,180);
      numbpriority:array[0..15] of byte=(0,15,55,60,65,70,75,80,85,90,0,95,130,145,190,195);

type priorityrec=record
                       iconno,priority,nearest:byte;
     end;
     queue_type=record
                      length:byte;
                      pitch:word;
     end;
     playerrec=record
                     supershots,megashots,threeway,saveyou:byte;
                     tailspeed,tailhold,deadlevel:byte;
                     score,lastscore,levscore:longint;
                     noicons,numbers,maxlen:word;
                     col,lives,gx,gy:byte;
                     head,tail,del:coord;
                     dir,ptype,eats:byte;
                     tailcount:word;
                     deadcount:word;
                     dead:boolean;
                     len:word;
     end;
     configrec=record
                     iconprobability,wormmethod,computerability:byte;
                     computerlaser,humanlaser,fastcomputers:boolean;
                     icononscreen,iconoffscreen,maxicons:byte;
                     playerspeed,playerlives:byte;
                     ptype:array[1..3] of byte;
                     levelendpoints:word;
     end;
     laserrec=record
                    x1,x2,y1,y2,dir:byte;
     end;
     scorerec=record
                    noicons,numbers,maxlen:word;
                    level,speed:byte;
                    name:string[25];
                    score:longint;
     end;
     iconrec=record
                   x,y,itype,action:byte;
                   doaction,numb:boolean;
                   howlong:word;
     end;
     keyrec=record
                  fire:boolean;
                  dir:byte;
     end;
     rankstr=string[4];
     namestr=string[25];
     logotype=array[1..14566] of byte;
     scorefile=array[1..40] of scorerec;

var exiton,escape,boss,snd,buffer,mrepeat,shutup,adding,levbonus:boolean;
    slowdowncount,speedupcount,speed,speedstore:array[1..3] of word;
    wormmoving,laser_onscreen,laser3way:array[1..3] of boolean;
    update_score,update_levelp,pause,endmessage:boolean;
    update,mpointscount,stuncount:array[1..3] of word;
    invcount,supercount,eatcount:array[1..3] of word;
    complist:array[1..maximumicons] of priorityrec;
    keybuffer:array[1..3,1..keybuffersize] of byte;
    special,both,mouseon,refreshbutt:boolean;
    scrtail:array[0..79,0..57,1..3] of word;
    icon:array[1..maximumicons] of iconrec;
    lasertype,lastdir:array[1..3] of byte;
    bufhead,buftail:array[1..3] of byte;
    divideby,multiply,kplayer,kdir:word;
    laser:array[1..3,1..3] of laserrec;
    comment:array[1..37] of string[60];
    soundq:array[1..255] of queue_type;
    screen:array[0..79,0..57] of byte;
    level,oval,ticks,worms_left:byte;
    zeropowercol:array[1..3] of word;
    player:array[0..3] of playerrec;
    nextlife:array[1..3] of longint;
    oldscore:array[0..3] of longint;
    powercol:array[1..3] of byte;
    key:array[1..3] of keyrec;
    icno,del,priority:word;
    levelpoints:longint;
    old09,old1C:pointer;
    wormtitle:^logotype;
    tempstr:string[80];
    hiscore:scorefile;
    ltp:string[3];
    temp:coord;
    ky:char;

procedure jcdgf;
procedure jcdfnt;
procedure wormlogo;

procedure addchord(n1,n2:word;clear:boolean);
procedure keyb_handler; interrupt;
procedure time_handler; interrupt;
procedure worm_theme;

procedure waitfor(sec:word;move,fire,allfire,timeout:boolean);
procedure button(text:string80;x,y,w,h,ud,hl,hlw:word;hlcol:byte;depth:word);
procedure addnote(npitch:word;nlength:byte;clear:boolean);
procedure grafcentln9(what:string;fg,bg:byte);
procedure grafcentln(what:string;fg,bg:byte);
procedure graftext(what:string;fg,bg:byte);
procedure grafcent(what:string;fg,bg:byte);
procedure draw_license_screen(clear:boolean);
function  worm_body(no:byte):byte;
function  worm_head(no:byte):byte;
procedure iconsound(icon:byte);
procedure load_configuration;
procedure save_configuration;
function  random_icon:byte;
procedure mouse_test;

procedure selectsound;
procedure disp_levelpoints;
procedure startoflevel(levelstuff:boolean);
procedure draw_button(no,pr:byte);
procedure disp_score(no:byte);
procedure disp_lives(no:byte);
procedure border(clear:boolean);
procedure help;

implementation

{***  Include graphics driver, fonts and Wiggly Worm '94 logo into program  ***}
procedure jcdgf;    external;  {$L EGAVGA.OBJ  }  {EGA/VGA graphics driver}
procedure jcdfnt;   external;  {$L SANS.OBJ    }  {Sansserif font}
procedure wormlogo; external;  {$L WORMLOGO.OBJ}  {Wiggly Worm '94 logo}

var headcycle:byte;


{$I INTERUPT.INC}

{Return current body colour of worm (Taking POWERCOL into account)}
function worm_body(no:byte):byte;
begin
     if powercol[no]>0 then worm_body := powercol[no] else
        worm_body:=player[no].col;
end;

{Return current head colour of worm}
function worm_head(no:byte):byte;
begin
     if((headcycle mod 18) < 15) then
     begin

          {***  Normal head colour  ***}
          if powercol[no]>0 then
          begin
               case powercol[no] of
             {Stun} 8:worm_head  := 4;  {Red}
      {Super Power} 9:worm_head  := 31; {Smiley face}
     {Invicibility} 10:worm_head := 7;  {Grey}
               end;
          end else
          begin
               case player[no].col of
            {Blue}  1:worm_head := 3;  {Cyan}
           {Green}  2:worm_head := 6;  {Yellow}
            {Cyan}  3:worm_head := 1;  {Blue}
             {Red}  4:worm_head := 6;  {Yellow}
         {Magenta}  5:worm_head := 6;  {Yellow}
          {Yellow}  6:worm_head := 4;  {Red}
            {Grey}  7:worm_head := 1;  {Blue}
               end;
          end;
     end else
     begin

          {***  Head colour change 'flash'  ***}
          if powercol[no]>0 then
          begin
               case powercol[no] of
             {Stun} 8:worm_head  := 6;  {Yellow}
      {Super Power} 9:worm_head  := 31; {Smiley face}
     {Invicibility} 10:worm_head := 7;  {Grey}
               end;
          end else
          begin
               case player[no].col of
            {Blue}  1:worm_head := 6;  {Yellow}
           {Green}  2:worm_head := 3;  {Cyan}
            {Cyan}  3:worm_head := 6;  {Yellow}
             {Red}  4:worm_head := 3;  {Cyan}
         {Magenta}  5:worm_head := 3;  {Cyan}
          {Yellow}  6:worm_head := 5;  {Magenta}
            {Grey}  7:worm_head := 3;  {Cyan}
               end;
          end;
     end;
end;

{Generate random icon number}
function random_icon:byte;
var rnd:byte;
begin
     rnd:=random(24)+1;
     if (rnd in [6,21..24]) then
     begin
          rnd:=random(100)+1;
          case rnd of
               1..50:rnd:=6;
               51..70:rnd:=22;
               71..85:rnd:=23;
               86..95:rnd:=24;
               96..100:rnd:=21;
          end;
     end;
     random_icon:=rnd;
end;

{Make sound for collecting an icon}
procedure iconsound(icon:byte);
var loop:word;
begin
     if priority<=sp_icon then
     begin
          priority:=sp_icon;
          case icon of
               1:begin
                      addnote(131,1,true);
                      addnote(262,1,false);
               end;
               2:begin
                      addnote(262,1,true);
                      addnote(131,1,false);
               end;
               3:begin
                      addnote(196,0,true);
                      addnote(250,0,false);
                      addnote(293,0,false);
                      addnote(196,0,false);
                      addnote(250,0,false);
                      addnote(293,0,false);
               end;
               4:begin
                      addnote(262,0,true);
                      addnote(333,0,false);
                      addnote(391,0,false);
                      addnote(262,0,false);
                      addnote(333,0,false);
                      addnote(391,0,false);
               end;
               5:begin
                      addnote(196,1,false);
                      addnote(0,0,false);
                      addnote(196,0,false);
                      addnote(0,0,false);
                      addnote(196,0,false);
                      addnote(0,0,false);
                      addnote(131,1,false);
               end;
               6:begin
                      addnote(131,0,true);
                      addnote(165,0,false);
                      addnote(196,0,false);
                      addnote(262,0,false);
                      addnote(333,0,false);
                      addnote(391,0,false);
                      addnote(524,0,false);
               end;
               7:begin
                      addnote(262,0,true);
                      addnote(250,0,false);
                      addnote(220,0,false);
                      addnote(196,0,false);
                      addnote(175,0,false);
                      addnote(165,0,false);
                      addnote(147,0,false);
                      addnote(131,0,false);
               end;
               8:begin
                      addnote(131,0,true);
                      addnote(147,0,false);
                      addnote(165,0,false);
                      addnote(175,0,false);
                      addnote(196,0,false);
                      addnote(220,0,false);
                      addnote(250,0,false);
                      addnote(262,0,false);
               end;
               9:begin
                      addnote(524,0,true);
                      addnote(660,0,false);
                      addnote(781,0,false);
                      addnote(524,0,false);
                      addnote(660,0,false);
                      addnote(781,0,false);
               end;
               10:begin
                       addnote(1100,0,true);
                       addnote(1050,0,false);
                       addnote(1100,0,false);
               end;
               11:begin
                       addnote(262,1,true);
                       addnote(278,1,false);
                       addnote(293,1,false);
               end;
               13..19:begin
                           addnote(123,0,true);
                           addnote(626,0,false);
                           addnote(262,0,false);
               end;
               22:begin
                       addnote(204,0,true);
                       for loop:=2 to 20 do addnote(200+(loop*4),0,false);
               end;
               23:begin
                       addnote(65,0,true);
                       addnote(33,0,false);
                       addnote(65,0,false);
                       addnote(33,0,false);
               end;
               24:begin
                       addnote(391,0,true);
                       addnote(246,0,false);
                       addnote(391,0,false);
                       addnote(246,0,false);
                       addnote(391,0,false);
                       addnote(246,0,false);
                       addnote(391,1,false);
                       addnote(246,0,false);
                       addnote(493,0,false);
                       addnote(293,0,false);
                       addnote(586,0,false);
                       addnote(391,0,false);
                       addnote(586,0,false);
                       addnote(391,0,false);
                       addnote(493,0,false);
                       addnote(293,0,false);
                       addnote(586,0,false);
                       addnote(391,0,false);
                       addnote(586,0,false);
                       addnote(391,0,false);
                       addnote(493,0,false);
                       addnote(293,0,false);
                       addnote(391,0,false);
                       addnote(98,0,false);
                       addnote(391,0,false);
                       addnote(98,0,false);
                       addnote(391,0,false);
                       addnote(98,0,false);
               end;
          end;
     end;
end;

{Save game configuration}
procedure save_configuration;
var cfgfile:file of configrec;
    cfg:configrec;
    loop:byte;

begin
     filemode:=2;
     assign(cfgfile,'\WORM94.CFG');

     for loop:=1 to 3 do cfg.ptype[loop]:=player[loop].ptype;
     cfg.iconprobability:=iconprobability;
     cfg.computerability:=computerability;
     cfg.levelendpoints:=levelendpoints;
     cfg.computerlaser:=computerlaser;
     cfg.iconoffscreen:=iconoffscreen;
     cfg.fastcomputers:=fastcomputers;
     cfg.icononscreen:=icononscreen;
     cfg.playerspeed:=playerspeed;
     cfg.playerlives:=playerlives;
     cfg.wormmethod:=wormmethod;
     cfg.humanlaser:=humanlaser;
     cfg.maxicons:=maxicons;

     {$I-}
     rewrite(cfgfile);
     write(cfgfile,cfg);
     close(cfgfile);
     {$I+}
     if ioresult<>0 then;
end;

{Load game configuration}
procedure load_configuration;
var cfgfile:file of configrec;
    cfg:configrec;
    loop:byte;

begin
     filemode:=0;
     assign(cfgfile,'\WORM94.CFG');
     {$I-}
     reset(cfgfile);
     read(cfgfile,cfg);
     close(cfgfile);
     {$I+}
     if ioresult=0 then
     begin
          for loop:=1 to 3 do player[loop].ptype:=cfg.ptype[loop];
          iconprobability:=cfg.iconprobability;
          computerability:=cfg.computerability;
          levelendpoints:=cfg.levelendpoints;
          computerlaser:=cfg.computerlaser;
          iconoffscreen:=cfg.iconoffscreen;
          fastcomputers:=cfg.fastcomputers;
          icononscreen:=cfg.icononscreen;
          playerspeed:=cfg.playerspeed;
          playerlives:=cfg.playerlives;
          wormmethod:=cfg.wormmethod;
          humanlaser:=cfg.humanlaser;
          maxicons:=cfg.maxicons;
     end;
     filemode:=2;
end;

{Add chord to sound queue}
procedure addchord(n1,n2:word;clear:boolean);
begin
     addnote(n1,0,clear);
     addnote(n2,0,false);
end;

{Draws button NO "unpressed" (2) or "pressed" (1)}
{NO:  (0) All  (1) VIEW HISCORES  (2) PLAY GAME  (3) QUIT}
procedure draw_button(no,pr:byte);
begin
     if (no in [0,1]) then button('VIEW HISCORES',30,mpos+290,128,18,13,1,1,red,pr);
     if (no in [0,2]) then button('PLAY GAME',181,mpos+290,128,18,9,1,1,red,pr);
     if (no in [0,3]) then button('QUIT TO DOS',331,mpos+290,128,18,11,1,1,red,pr);
     if (no in [0,4]) then button('? HELP',482,mpos+290,128,18,6,1,1,red,pr);
     if (no in [0,10]) then case player[1].ptype of
       0:button('PLAYER 1:  Not playing                                               ',30,mpos,580,18,11,8,1,lightblue,pr);
       1:button('PLAYER 1:  Human  (Z Left, X Right, F Up, C Down and G Fire)         ',30,mpos,580,18,11,8,1,lightblue,pr);
       2:button('PLAYER 1:  Computer controlled                                       ',30,mpos,580,18,11,8,1,lightblue,pr);
     end;
     if (no in [0,11]) then case player[2].ptype of
       0:button('PLAYER 2:  Not playing                                               ',30,mpos+20,580,18,11,8,1,lightblue,pr);
       1:button('PLAYER 2:  Human  (1 Left, 2 Right, 6 Up, 3 Down and + Fire) (Keypad)',30,mpos+20,580,18,11,8,1,lightblue,pr);
       2:button('PLAYER 2:  Computer controlled                                       ',30,mpos+20,580,18,11,8,1,lightblue,pr);
     end;
     if (no in [0,12]) then case player[3].ptype of
       0:button('PLAYER 3:  Not playing                                               ',30,mpos+40,580,18,11,8,1,lightblue,pr);
       1:button('PLAYER 3:  Human  (U Left, I Right, 0 (Zero) Up, O Down and - Fire)  ',30,mpos+40,580,18,11,8,1,lightblue,pr);
       2:button('PLAYER 3:  Computer controlled                                       ',30,mpos+40,580,18,11,8,1,lightblue,pr);
     end;
     if (no in [0,20]) then if computerlaser then button('COMPUTERS CAN USE LASER:  Yes',30,mpos+70,280,18,26,1,1,magenta,pr)
        else button('COMPUTERS CAN USE LASER:  No ',30,mpos+70,280,18,26,1,1,magenta,pr);
     if (no in [0,21]) then if humanlaser then button('HUMANS CAN USE LASER:  Yes',330,mpos+70,280,18,23,1,1,magenta,pr) else
        button('HUMANS CAN USE LASER:  No ',330,mpos+70,280,18,23,1,1,magenta,pr);
     if (no in [0,30]) then button('- + GAME SPEED (Lower = faster):  '+trunc_str(convert(playerspeed),2),
         30,mpos+100,320,18,34,1,3,magenta,pr);
     if (no in [0,31]) then button('LIVES PER PLAYER:  '+trunc_str(convert(playerlives),2),370,mpos+100,240,18,19,1,1,5,pr);
     if (no in [0,40]) then case iconprobability of
        0..1:button(' ICONS vs NUMBERS PROBABILTY:  Numbers only (No icons)               ',30,mpos+130,580,18,30,2,1,10,pr);
        2..4:button(' ICONS vs NUMBERS PROBABILTY:  Very few icons, loadsa numbers        ',30,mpos+130,580,18,30,2,1,10,pr);
        5..6:button(' ICONS vs NUMBERS PROBABILTY:  Few icons, lots of numbers  (Default) ',30,mpos+130,580,18,30,2,1,10,pr);
        7..9:button(' ICONS vs NUMBERS PROBABILTY:  Quite a few icons, many numbers       ',30,mpos+130,580,18,30,2,1,10,pr);
        10..12:button(' ICONS vs NUMBERS PROBABILTY:  Equal number of icons and numbers     ',30,mpos+130,580,18,30,2,1,10,pr);
        13..14:button(' ICONS vs NUMBERS PROBABILTY:  Many icons, quite a few numbers       ',30,mpos+130,580,18,30,2,1,10,pr);
        15..17:button(' ICONS vs NUMBERS PROBABILTY:  Lots of icons, few numbers            ',30,mpos+130,580,18,30,2,1,10,pr);
        18..19:button(' ICONS vs NUMBERS PROBABILTY:  Loadsa icons, very few numbers        ',30,mpos+130,580,18,30,2,1,10,pr);
        20:button(' ICONS vs NUMBERS PROBABILTY:  Icons only (No numbers)               ',30,mpos+130,580,18,30,2,1,10,pr);
     end;
     if (no in [0,41]) then case wormmethod of
        1:button('  WORM LENGTH AFTER CRASHING:  10% of length                         ',30,mpos+150,580,18,30,3,1,10,pr);
        2:button('  WORM LENGTH AFTER CRASHING:  20% of length                         ',30,mpos+150,580,18,30,3,1,10,pr);
        3:button('  WORM LENGTH AFTER CRASHING:  30% of length                         ',30,mpos+150,580,18,30,3,1,10,pr);
        4:button('  WORM LENGTH AFTER CRASHING:  40% of length                         ',30,mpos+150,580,18,30,3,1,10,pr);
        5:button('  WORM LENGTH AFTER CRASHING:  50% of length               (Default) ',30,mpos+150,580,18,30,3,1,10,pr);
        6:button('  WORM LENGTH AFTER CRASHING:  60% of length                         ',30,mpos+150,580,18,30,3,1,10,pr);
        7:button('  WORM LENGTH AFTER CRASHING:  70% of length                         ',30,mpos+150,580,18,30,3,1,10,pr);
        8:button('  WORM LENGTH AFTER CRASHING:  80% of length                         ',30,mpos+150,580,18,30,3,1,10,pr);
        9:button('  WORM LENGTH AFTER CRASHING:  90% of length                         ',30,mpos+150,580,18,30,3,1,10,pr);
        10:button('  WORM LENGTH AFTER CRASHING:  Stays the same                        ',30,mpos+150,580,18,30,3,1,10,pr);
     end;
     if (no in [0,42]) then case levelendpoints div 100 of
        2:button('            LEVEL DIFFICULTY:  Dead easy                             ',30,mpos+170,580,18,30,19,1,10,pr);
        5:button('            LEVEL DIFFICULTY:  Easy                                  ',30,mpos+170,580,18,30,19,1,10,pr);
        10:button('            LEVEL DIFFICULTY:  Normal                                ',30,mpos+170,580,18,30,19,1,10,pr);
        15:button('            LEVEL DIFFICULTY:  Quite hard                            ',30,mpos+170,580,18,30,19,1,10,pr);
        20:button('            LEVEL DIFFICULTY:  Hard                                  ',30,mpos+170,580,18,30,19,1,10,pr);
        30:button('            LEVEL DIFFICULTY:  Very hard                             ',30,mpos+170,580,18,30,19,1,10,pr);
     end;
     if (no in [0,43]) then case computerability of
        0:button('    COMPUTER PLAYING ABILITY:  Perfect                               ',30,mpos+190,580,18,30,6,1,10,pr);
        1:button('    COMPUTER PLAYING ABILITY:  Almost perfect                        ',30,mpos+190,580,18,30,6,1,10,pr);
        10:button('    COMPUTER PLAYING ABILITY:  Extremely good              (Default) ',30,mpos+190,580,18,30,6,1,10,pr);
        20:button('    COMPUTER PLAYING ABILITY:  Quite good                            ',30,mpos+190,580,18,30,6,1,10,pr);
        35:button('    COMPUTER PLAYING ABILITY:  Good                                  ',30,mpos+190,580,18,30,6,1,10,pr);
        50:button('    COMPUTER PLAYING ABILITY:  Reasonable                            ',30,mpos+190,580,18,30,6,1,10,pr);
        70:button('    COMPUTER PLAYING ABILITY:  Not very good                         ',30,mpos+190,580,18,30,6,1,10,pr);
        85:button('    COMPUTER PLAYING ABILITY:  Awful                                 ',30,mpos+190,580,18,30,6,1,10,pr);
        95:button('    COMPUTER PLAYING ABILITY:  Extremely bad                         ',30,mpos+190,580,18,30,6,1,10,pr);
        100:button('    COMPUTER PLAYING ABILITY:  Absolutely hopeless!                  ',30,mpos+190,580,18,30,6,1,10,pr);
     end;
     if (no in [0,44]) then if fastcomputers then
        button('FAST COMPUTER PLAYERS OPTION:  When there are no human players left  ',30,mpos+210,580,18,30,2,1,10,pr) else
        button('FAST COMPUTER PLAYERS OPTION:  Off                                   ',30,mpos+210,580,18,30,2,1,10,pr);
     if (no in [0,50]) then
        button('ICONS ON SCREEN:  Max. '+trunc_str(convert(icononscreen)+' secs',7),30,mpos+240,289,18,18,8,1,lightcyan,pr);
     if (no in [0,51]) then
        button('ICONS OFF SCREEN:  Max. '+trunc_str(convert(iconoffscreen)+' secs',7),321,mpos+240,289,18,19,9,1,lightcyan,pr);
     if (no in [0,52]) then if maxicons=5 then
        button('MAXIMUM NUMBER OF ICONS ON SCREEN:  5  (Default)',30,mpos+260,580,18,36,1,1,lightcyan,pr) else
        button('MAXIMUM NUMBER OF ICONS ON SCREEN:  '+trunc_str(convert(maxicons),12),30,mpos+260,580,18,36,1,1,lightcyan,pr);
     if no=200 then button('OK',256,mpos+290,128,18,2,1,1,red,pr);
     if no=100 then button(#25+' '+#26+' NEXT PAGE',30,mpos+290,128,18,13,1,5,red,pr);
     if no=105 then button(#24+' '+#27+' PREV PAGE',181,mpos+290,128,18,13,1,5,red,pr);
     if no=110 then button('OK',482,mpos+290,128,18,2,1,1,red,pr);
end;

{Test if mouse has been clicked on a button}
procedure mouse_test;
var clicked,zone:byte;
begin
     clicked:=get_mousebutt;
     if mouse_grafzone(30,mpos+290,128,18) then zone:=1 else
        if mouse_grafzone(180,mpos+290,128,18) then zone:=2 else
        if mouse_grafzone(330,mpos+290,128,18) then zone:=3 else
        if mouse_grafzone(480,mpos+290,128,18) then zone:=4 else
        if mouse_grafzone(30,mpos,580,18) then zone:=10 else
        if mouse_grafzone(30,mpos+20,580,18) then zone:=11 else
        if mouse_grafzone(30,mpos+40,580,18) then zone:=12 else
        if mouse_grafzone(30,mpos+70,280,18) then zone:=20 else
        if mouse_grafzone(330,mpos+70,280,18) then zone:=21 else
        if mouse_grafzone(30,mpos+100,320,18) then zone:=30 else
        if mouse_grafzone(370,mpos+100,240,18) then zone:=31 else
        if mouse_grafzone(30,mpos+130,580,18) then zone:=40 else
        if mouse_grafzone(30,mpos+150,580,18) then zone:=41 else
        if mouse_grafzone(30,mpos+170,580,18) then zone:=42 else
        if mouse_grafzone(30,mpos+190,580,18) then zone:=43 else
        if mouse_grafzone(30,mpos+210,580,18) then zone:=44 else
        if mouse_grafzone(30,mpos+240,289,18) then zone:=50 else
        if mouse_grafzone(321,mpos+240,289,18) then zone:=51 else
        if mouse_grafzone(30,mpos+260,580,18) then zone:=52 else
           zone:=0;
     if clicked<>0 then
     begin
          case zone of
               1:buffer_write('V',false);
               2:buffer_write('P',false);
               3:buffer_write('Q',false);
               4:buffer_write('?',false);
               10:buffer_write('1',false);
               11:buffer_write('2',false);
               12:buffer_write('3',false);
               20:buffer_write('C',false);
               21:buffer_write('H',false);
               30:buffer_write('+',false);
               31:buffer_write('L',false);
               40:buffer_write('I',false);
               41:buffer_write('W',false);
               42:buffer_write('D',false);
               43:buffer_write('O',false);
               44:buffer_write('A',false);
               50:buffer_write('N',false);
               51:buffer_write('F',false);
               52:buffer_write('M',false);
          end;
          if clicked>2 then both:=true;
          if clicked=1 then special:=true;
     end;
end;

{Draw a "button"}
procedure button(text:string80;x,y,w,h,ud,hl,hlw:word;hlcol:byte;depth:word);
var loop:byte;

{Write some text to the screen}
procedure grafbutt(x,y:word;text:string80;ud,hl,hlw:word;fg,bg,hfg,hbg:byte);
var hltext:string80;
    loop:byte;

begin
     if ud>0 then
     begin
          for loop:=1 to ud do text[loop]:=' ';
          setfillstyle(1,lightgray);
          bar(x+(8*ud),y,x+(8*length(text)),y+9);
     end;
     hltext:=copy(text,hl,hlw);
     if hltext<>'' then for loop:=1 to length(hltext) do text[hl+loop-1]:=' ';
     while length(hltext)<hl do hltext:=' '+hltext;
     text[hl]:=' ';
     {***  Button text  ***}
     setcolor(bg);
     outtextxy(x,y+1,text);
     setcolor(fg);
     outtextxy(x,y,text);
     {***  Hilighted letter  ***}
     setcolor(hbg);
     outtextxy(x,y+1,hltext);
     setcolor(hfg);
     outtextxy(x,y,hltext);
end;

begin
     if mouseon then mouse_curs(off);
     if refreshbutt then ud:=0;
     dec(w); dec(h);
     if ud=0 then
     begin
          setfillstyle(1,lightgray);
          bar(x+depth,y+depth,x+w-depth,y+h-depth);
     end;
     setcolor(black);
     rectangle(x-1,y-1,x+w+1,y+h+1);
     if depth>0 then
     begin
          for loop:=0 to 3 do if loop<depth then
          begin
               setcolor(white);
               line(x,y+loop,x+w-loop,y+loop);
               line(x+loop,y,x+loop,y+h-loop);
               setcolor(darkgray);
               line(x+w-loop,y+1+loop,x+w-loop,y+h);
               line(x+1+loop,y+h-loop,x+w,y+h-loop);
          end else
          begin
               setcolor(lightgray);
               rectangle(x+loop,y+loop,x+w-loop,y+h-loop);
          end;
     end;
     grafbutt(x+((succ(w)-textwidth(text)) div 2),y+((succ(h)-textheight(text)) div 2),text,ud,hl,hlw,
              black,darkgray,hlcol,black);
     if mouseon then mouse_curs(on);
end;

{Output some text using colours fgcl and bgcl}
procedure graftext(what:string;fg,bg:byte);
begin
     setcolor(bg);
     outtextxy(gf.x*8,succ(gf.y*8),what);
     setcolor(fg);
     outtextxy(gf.x*8,gf.y*8,what);
end;

{Centre some text using colours fg and bg}
procedure grafcent(what:string;fg,bg:byte);
var x:word;
begin
     x:=(640-(length(what)*8)) div 2;
     setcolor(bg);
     outtextxy(x,succ(gf.y*8),what);
     setcolor(fg);
     outtextxy(x,gf.y*8,what);
end;

{Centre some text using colours fg and bg and move down a line}
procedure grafcentln(what:string;fg,bg:byte);
var x:word;
begin
     x:=(640-(length(what)*8)) div 2;
     setcolor(bg);
     outtextxy(x,succ(gf.y*8),what);
     setcolor(fg);
     outtextxy(x,gf.y*8,what);
     gf.x:=1;
     inc(gf.y);
end;

{Centre some text using colours fg and bg and move down a line}
procedure grafcentln9(what:string;fg,bg:byte);
var x:word;
begin
     x:=(640-(length(what)*8)) div 2;
     setcolor(bg);
     outtextxy(x,succ(gf.y*9),what);
     setcolor(fg);
     outtextxy(x,gf.y*9,what);
     gf.x:=1;
     inc(gf.y);
end;

{Add note to sound queue}
procedure addnote(npitch:word;nlength:byte;clear:boolean);
begin
     adding:=true;  {Prevent note from being played while being added!}
     if clear then
     begin
          qpos:=1;
          qlen:=0;
          ticks:=0;
     end;
     inc(qlen);
     soundq[qlen].pitch:=npitch;
     soundq[qlen].length:=nlength;
     adding:=false;
end;

{Make selection sound (Blub, blub blub, blub!)}
procedure selectsound;
begin
     mrepeat:=false;
     addnote(587,0,true);
     addnote(494,0,false);
     addnote(587,0,false);
     addnote(781,0,false);
end;

{Wait for SEC seconds with optionally continue before SEC seconds have passed}
procedure waitfor(sec:word;move,fire,allfire,timeout:boolean);
var cont:boolean;
    loop,nofire,hums:byte;

begin
     hums:=0;
     nofire:=0;
     del:=round(sec*18.2);
     if allfire then
     begin
          for loop:=1 to 3 do if player[loop].ptype=human then
          begin
               key[loop].fire:=false;
               inc(nofire);
          end else key[loop].fire:=false;
          if nofire=0 then nofire:=1;
     end else
     begin
          key[1].fire:=false;
          key[2].fire:=false;
          key[3].fire:=false;
          nofire:=1;
     end;
     for loop:=1 to 3 do if (player[loop].ptype=human) and not player[loop].dead then inc(hums);
     key[1].dir:=5; key[2].dir:=5; key[3].dir:=5;
     if hums=0 then timeout:=true;
     repeat
           cont:=false;
           if timeout and (del=0) then cont:=true;
           if move and not ((key[1].dir=5) and (key[2].dir=5) and (key[3].dir=5)) then cont:=true;
           if fire then
           begin
                if (key[1].fire or key[2].fire or key[3].fire) then if nofire>0 then dec(nofire);
                if nofire=0 then cont:=true;
           end;
     until cont or escape;
     if key[1].fire or key[2].fire or key[3].fire then selectsound;
     pause:=false;
end;

{Displays score of player NO}
procedure disp_score(no:byte);
var x:word;
begin
     if oldscore[no]<>player[no].score then
     begin
          oldscore[no]:=player[no].score;
          if player[no].score<0 then player[no].score:=0;
          case no of
               1:x:=56;
               2:x:=208;
               3:x:=360;
          end;
          setfillstyle(1,lightblue);
          bar(x,11,x+63,18);
          setcolor(blue);
          outtextxy(x,12,convert(player[no].score));
          setcolor(lightcyan);
          outtextxy(x,11,convert(player[no].score));
     end;
end;

{Displays lives of player NO}
procedure disp_lives(no:byte);
var x:word;
begin
     case no of
          1:x:=128;
          2:x:=280;
          3:x:=432;
     end;
     if player[no].lives=0 then ltp:='RIP' else
        ltp:='L'+convert(player[no].lives);
     setfillstyle(1,lightblue);
     bar(x,11,x+23,18);
     setcolor(blue);
     outtextxy(x,12,ltp);
     setcolor(lightcyan);
     outtextxy(x,11,ltp);
end;

{Display level points to go before end of level}
procedure disp_levelpoints;
begin
     if oldscore[0]<>levelpoints then
     begin
          if levelpoints<0 then levelpoints:=0;
          oldscore[0]:=levelpoints;
          setfillstyle(1,lightblue);
          bar(584,11,584+39,18);
          setcolor(blue);
          outtextxy(584,12,trunc_str(convert(levelpoints),6));
          setcolor(lightcyan);
          outtextxy(584,11,trunc_str(convert(levelpoints),6));
     end;
end;

{Do start of level stuff}
procedure startoflevel(levelstuff:boolean);
var x,y:word;
    c:byte;

begin
     inc(level);
     if level=0 then level:=1;
     levelpoints:=longint(level)*longint(levelendpoints);
     for x:=1 to 3 do player[x].deadlevel:=level;
     if levelpoints>99999 then levelpoints:=99999;
     {***  Display level user is on and level points to go  ***}
     setfillstyle(1,lightblue);
     bar(544,11,544+23,18);
     setcolor(blue);
     outtextxy(544,12,convert(level));
     setcolor(lightcyan);
     outtextxy(544,11,convert(level));
     disp_levelpoints;
     if levelstuff then
     begin
          {***  Briefly display level in big text ***}
          settextstyle(sansseriffont,horizdir,6);
          tempstr:='LEVEL '+convert(level);
          x:=((640-textwidth(tempstr)) div 2)+8;
          y:=((480-textheight(tempstr)) div 2)-12;
          c:=random(7)+9;
          setcolor(black);
          outtextxy(x-1,y-1,tempstr);
          outtextxy(x-1,y+2,tempstr);
          outtextxy(x+1,y-1,tempstr);
          outtextxy(x+1,y+2,tempstr);
          setcolor(lightgray);
          outtextxy(x,y+1,tempstr);
          setcolor(c);
          outtextxy(x,y,tempstr);
          waitfor(2,true,true,false,true);
          setfillstyle(1,black);
          bar(x-8,y+10,x+textwidth(tempstr)+8,y+textheight(tempstr)+8);
          settextstyle(defaultfont,horizdir,1);
     end;
end;

{Draws border graphics}
procedure border(clear:boolean);
begin
     setcolor(white);
     rectangle(2,2,637,477);
     line(3,26,636,26);
     setcolor(lightgray);
     rectangle(3,3,636,25);
     rectangle(3,27,636,476);
     line(2,1,637,1);
     line(2,478,637,478);
     line(1,2,1,477);
     line(638,2,638,477);
     setcolor(darkgray);
     rectangle(4,4,635,24);
     rectangle(4,28,635,475);
     rectangle(7,31,632,472);
     line(2,0,637,0);
     line(2,479,637,479);
     line(0,2,0,477);
     line(639,2,639,477);
     putpixel(1,1,darkgray);
     putpixel(638,1,darkgray);
     putpixel(1,478,darkgray);
     putpixel(638,478,darkgray);
     setcolor(blue);
     rectangle(5,5,634,23);
     setcolor(blue);
     rectangle(6,6,633,22);
     if clear then
     begin
          setfillstyle(1,lightblue);
          bar(7,7,632,21);
          setcolor(blue);
          outtextxy(16,12,'1UP:          L    2UP:          L    3UP:          L      LEVEL:');
          setcolor(lightcyan);
          outtextxy(16,11,'1UP:          L    2UP:          L    3UP:          L      LEVEL:');
          disp_score(1); disp_lives(1);
          disp_score(2); disp_lives(2);
          disp_score(3); disp_lives(3);
          startoflevel(false);
     end;
end;

{Draw license info screen}
procedure draw_license_screen(clear:boolean);
begin
     mrepeat:=false;
     worm_theme;
     border(clear);

     {***  Copyright and all time champion display  ***}
     grafxy(1,57);
     grafcent('Written by J.P.Boggis '+verdate+'  -  (C)Copyright 1994-2001',lightgray,darkgray);
     grafxy(1,5);
     grafcent('All time champion:  '+trunc_str('',length(hiscore[1].name))+' with a score of '+trunc_str('',
              length(convert(hiscore[1].score))),lightgreen,green);
     grafcent('                    '+hiscore[1].name+'                 '+trunc_str('',length(convert(
              hiscore[1].score))),white,lightgray);
     grafcentln('                    '+trunc_str('',length(hiscore[1].name))+'                 '+convert(hiscore[1].
                score),lightcyan,cyan);

     {***  Wiggly Worm '94 title  ***}
     putimage(41,57,wormtitle^,normalput);
     grafxy(62,13);
     graftext('Special Edition',lightmagenta,magenta);

     {***  Buttons  ***}
     setcolor(lightgray);
     rectangle(20,mpos-9,621,mpos+317);
     setcolor(white);
     rectangle(19,mpos-10,620,mpos+316);
     setcolor(lightblue);
     rectangle(22,mpos-7,618,mpos+314);
     setfillstyle(1,blue);
     bar(23,mpos-6,617,mpos+313);
     refreshbutt:=true;
     draw_button(200,2);
     refreshbutt:=false;

     {***  Display version number  ***}
     grafxy(5,53);
     graftext('v'+ver,black,lightblue);

     {***  License information  ***}
     license(true,true);

     {***  Wait for user to press or click on OK  ***}
     ky:=#255;
     buffer_write('',false);
     if mouseon then
     begin
          mouse_curs(on);
          repeat until get_mousebutt=0;
     end;
     repeat
           if mouseon then if (get_mousebutt>0) and mouse_grafzone(256,mpos+290,128,18) then
              buffer_write('O',false);
           if keypressed then
           begin
                ky:=upcase(readkey);
                if ky=#0 then
                begin
                     ky:=readkey;
                     ky:=#255;
                end;
                if (ky<>#255) and (ky in ['O','Y',#13]) then
                begin
                     selectsound;
                     draw_button(200,1);
                     del:=2;
                     repeat until del=0;
                     draw_button(200,2);
                     escape:=true;
                end;
           end;
     until escape;
     if mouseon then
     begin
          repeat until get_mousebutt=0;
          mouse_curs(off);
     end;
     if not boss then escape:=false;
     ky:=#255;
end;

{Help screen}
procedure help;
var mb:byte;
begin
     {***  Buttons  ***}
     setcolor(lightgray);
     rectangle(20,mpos-9,621,mpos+317);
     setcolor(white);
     rectangle(19,mpos-10,620,mpos+316);
     setcolor(lightblue);
     rectangle(22,mpos-7,618,mpos+314);
     setfillstyle(1,blue);
     bar(23,mpos-6,617,mpos+313);
     refreshbutt:=true;
     draw_button(100,2);
     draw_button(105,2);
     draw_button(110,2);
     refreshbutt:=false;

     disp_helppage(true);

     {***  Allow user to click on buttons or use keyboard  ***}
     ky:=#255;
     buffer_write('',false);
     if mouseon then
     begin
          mouse_curs(on);
          repeat until get_mousebutt=0;
     end;
     repeat
           mb:=get_mousebutt;
           if mouseon and (mb>0) then
           begin
                if mouse_grafzone(30,mpos+290,128,18) then case mb of
                   1,2:buffer_write('N',false);
                   else buffer_write(#71,true);
                end;
                if mouse_grafzone(180,mpos+290,128,18) then case mb of
                   1,2:buffer_write('P',false);
                   else buffer_write(#79,true);
                end;
                if mouse_grafzone(480,mpos+290,128,18) then buffer_write('O',false);
           end;
           if keypressed then
           begin
                ky:=upcase(readkey);
                if (ky in [#0,'N','P']) then
                begin
                     case ky of
                          'N':ky:=#80;
                          'P':ky:=#72;
                          else ky:=readkey;
                     end;
                     case ky of
                          #72,#75,#73:  {***  Previous page  ***}
                          begin
                               selectsound;
                               draw_button(105,1);
                               del:=2;
                               repeat until del=0;
                               draw_button(105,2);
                               if mouseon then mouse_curs(off);
                               dec(page);
                               if page=0 then page:=maxpages;
                               if not (page in [6..10,12..15]) then disp_helppage(true) else
                                  disp_helppage(false);
                               if mouseon then mouse_curs(on);
                          end;
                          #80,#77,#81:  {***  Next page  ***}
                          begin
                               selectsound;
                               draw_button(100,1);
                               del:=2;
                               repeat until del=0;
                               draw_button(100,2);
                               if mouseon then mouse_curs(off);
                               inc(page);
                               if page>maxpages then page:=1;
                               if not (page in [7..11,13..16]) then disp_helppage(true) else
                                  disp_helppage(false);
                               if mouseon then mouse_curs(on);
                          end;
                          #71,#119:if page>1 then  {***  First page (HOME)  ***}
                          begin
                               selectsound;
                               if mouseon then mouse_curs(off);
                               page:=1;
                               disp_helppage(true);
                               if mouseon then mouse_curs(on);
                          end;
                          #79,#117:if page<maxpages then  {***  Last page (END)  ***}
                          begin
                               selectsound;
                               if mouseon then mouse_curs(off);
                               page:=maxpages;
                               disp_helppage(true);
                               if mouseon then mouse_curs(on);
                          end;
                     end;
                     ky:=#255;
                end;
                if (ky<>#255) and (ky in ['O','Y',#13,#27]) then
                begin
                     selectsound;
                     draw_button(110,1);
                     del:=2;
                     repeat until del=0;
                     draw_button(110,2);
                     escape:=true;
                end;
           end;
     until escape;
     if mouseon then
     begin
          repeat until get_mousebutt=0;
          mouse_curs(off);
     end;
     if not boss then escape:=false;
     ky:=#255;
end;

begin
     refreshbutt:=true;
     headcycle:=0;
end.